diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-ppdu.h ns-3.38/src/wifi/model/wifi-ppdu.h
--- ns-3.37/src/wifi/model/wifi-ppdu.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-ppdu.h	2023-03-16 20:54:23.868869300 -0700
@@ -25,6 +25,7 @@
 #include "ns3/nstime.h"
 
 #include <list>
+#include <optional>
 #include <unordered_map>
 
 /**
@@ -37,6 +38,7 @@
 namespace ns3
 {
 
+class Packet;
 class WifiPsdu;
 
 /**
@@ -87,7 +89,19 @@
      *
      * \return the TXVECTOR of the PPDU.
      */
-    WifiTxVector GetTxVector() const;
+    const WifiTxVector& GetTxVector() const;
+
+    /**
+     * Reset the TXVECTOR.
+     */
+    void ResetTxVector() const;
+
+    /**
+     * Update the TXVECTOR based on some information known at the receiver.
+     *
+     * \param updatedTxVector the updated TXVECTOR.
+     */
+    void UpdateTxVector(const WifiTxVector& updatedTxVector) const;
 
     /**
      * Get the payload of the PPDU.
@@ -122,6 +136,11 @@
     virtual uint16_t GetTransmissionChannelWidth() const;
 
     /**
+     * \return the center frequency (MHz) used for the transmission of this PPDU
+     */
+    uint16_t GetTxCenterFreq() const;
+
+    /**
      * Check whether the given PPDU overlaps a given channel.
      *
      * \param minFreq the minimum frequency (MHz) of the channel
@@ -131,17 +150,6 @@
     bool DoesOverlapChannel(uint16_t minFreq, uint16_t maxFreq) const;
 
     /**
-     * Check whether the given PPDU can be received on the specified primary
-     * channel. Normally, a PPDU can be received if it is transmitted over a
-     * channel that overlaps the primary20 channel of a PHY entity.
-     *
-     * \param p20MinFreq the minimum frequency (MHz) of the primary channel
-     * \param p20MaxFreq the maximum frequency (MHz) of the primary channel
-     * \return true if this PPDU can be received, false otherwise
-     */
-    virtual bool CanBeReceived(uint16_t p20MinFreq, uint16_t p20MaxFreq) const;
-
-    /**
      * Get the modulation used for the PPDU.
      * \return the modulation used for the PPDU
      */
@@ -195,6 +203,13 @@
     WifiConstPsduMap m_psdus;         //!< the PSDUs contained in this PPDU
     uint16_t m_txCenterFreq; //!< the center frequency (MHz) used for the transmission of this PPDU
     uint64_t m_uid;          //!< the unique ID of this PPDU
+    mutable std::optional<WifiTxVector>
+        m_txVector; //!< the TXVECTOR at TX PHY or the reconstructed TXVECTOR at RX PHY (or
+                    //!< std::nullopt if TXVECTOR has not been reconstructed yet)
+
+#ifdef NS3_BUILD_PROFILE_DEBUG
+    Ptr<Packet> m_phyHeaders; //!< the PHY headers contained in this PPDU
+#endif
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-protection.cc ns-3.38/src/wifi/model/wifi-protection.cc
--- ns-3.37/src/wifi/model/wifi-protection.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-protection.cc	2023-03-16 20:54:23.868869300 -0700
@@ -102,6 +102,27 @@
     os << "CTS_TO_SELF";
 }
 
+/*
+ * WifiMuRtsCtsProtection
+ */
+
+WifiMuRtsCtsProtection::WifiMuRtsCtsProtection()
+    : WifiProtection(MU_RTS_CTS)
+{
+}
+
+std::unique_ptr<WifiProtection>
+WifiMuRtsCtsProtection::Copy() const
+{
+    return std::unique_ptr<WifiProtection>(new WifiMuRtsCtsProtection(*this));
+}
+
+void
+WifiMuRtsCtsProtection::Print(std::ostream& os) const
+{
+    os << "MU_RTS_CTS";
+}
+
 std::ostream&
 operator<<(std::ostream& os, const WifiProtection* protection)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-protection.h ns-3.38/src/wifi/model/wifi-protection.h
--- ns-3.37/src/wifi/model/wifi-protection.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-protection.h	2023-03-16 20:54:23.868869300 -0700
@@ -47,7 +47,8 @@
     {
         NONE = 0,
         RTS_CTS,
-        CTS_TO_SELF
+        CTS_TO_SELF,
+        MU_RTS_CTS
     };
 
     /**
@@ -118,6 +119,23 @@
 };
 
 /**
+ * \ingroup wifi
+ *
+ * WifiMuRtsCtsProtection specifies that MU-RTS/CTS protection method is used.
+ */
+struct WifiMuRtsCtsProtection : public WifiProtection
+{
+    WifiMuRtsCtsProtection();
+
+    // Overridden from WifiProtection
+    std::unique_ptr<WifiProtection> Copy() const override;
+    void Print(std::ostream& os) const override;
+
+    CtrlTriggerHeader muRts;    //!< MU-RTS
+    WifiTxVector muRtsTxVector; //!< MU-RTS TXVECTOR
+};
+
+/**
  * \brief Stream insertion operator.
  *
  * \param os the output stream
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-protection-manager.cc ns-3.38/src/wifi/model/wifi-protection-manager.cc
--- ns-3.37/src/wifi/model/wifi-protection-manager.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-protection-manager.cc	2023-03-16 20:54:23.868869300 -0700
@@ -19,7 +19,8 @@
 
 #include "wifi-protection-manager.h"
 
-#include "wifi-mac.h"
+#include "ap-wifi-mac.h"
+#include "wifi-phy.h"
 
 #include "ns3/log.h"
 
@@ -77,4 +78,45 @@
     m_linkId = linkId;
 }
 
+void
+WifiProtectionManager::AddUserInfoToMuRts(CtrlTriggerHeader& muRts,
+                                          uint16_t txWidth,
+                                          const Mac48Address& receiver) const
+{
+    NS_LOG_FUNCTION(this << muRts << txWidth << receiver);
+
+    CtrlTriggerUserInfoField& ui = muRts.AddUserInfoField();
+
+    NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send MU-RTS");
+    auto apMac = StaticCast<ApWifiMac>(m_mac);
+    ui.SetAid12(apMac->GetAssociationId(receiver, m_linkId));
+
+    const uint16_t ctsTxWidth =
+        std::min(txWidth, GetWifiRemoteStationManager()->GetChannelWidthSupported(receiver));
+    auto phy = m_mac->GetWifiPhy(m_linkId);
+    std::size_t primaryIdx = phy->GetOperatingChannel().GetPrimaryChannelIndex(ctsTxWidth);
+    if (phy->GetChannelWidth() == 160 && ctsTxWidth <= 40 && primaryIdx >= 80 / ctsTxWidth)
+    {
+        // the primary80 is in the higher part of the 160 MHz channel
+        primaryIdx -= 80 / ctsTxWidth;
+    }
+    switch (ctsTxWidth)
+    {
+    case 20:
+        ui.SetMuRtsRuAllocation(61 + primaryIdx);
+        break;
+    case 40:
+        ui.SetMuRtsRuAllocation(65 + primaryIdx);
+        break;
+    case 80:
+        ui.SetMuRtsRuAllocation(67);
+        break;
+    case 160:
+        ui.SetMuRtsRuAllocation(68);
+        break;
+    default:
+        NS_ABORT_MSG("Unhandled TX width: " << ctsTxWidth << " MHz");
+    }
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-protection-manager.h ns-3.38/src/wifi/model/wifi-protection-manager.h
--- ns-3.37/src/wifi/model/wifi-protection-manager.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-protection-manager.h	2023-03-16 20:54:23.868869300 -0700
@@ -98,6 +98,21 @@
      */
     Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager() const;
 
+    /**
+     * Add a User Info field to the given MU-RTS Trigger Frame to solicit a CTS from
+     * the station with the given MAC address. The MU-RTS is intended to protect a data
+     * frame having the given TX width. The TX width of the solicited CTS is the minimum
+     * between the TX width of the protected data frame and the maximum width supported
+     * by the solicited station.
+     *
+     * \param muRts the MU-RTS Trigger Frame
+     * \param txWidth the TX width of the protected data frame
+     * \param receiver the MAC address of the solicited station
+     */
+    void AddUserInfoToMuRts(CtrlTriggerHeader& muRts,
+                            uint16_t txWidth,
+                            const Mac48Address& receiver) const;
+
     Ptr<WifiMac> m_mac; //!< MAC which is using this Protection Manager
     uint8_t m_linkId;   //!< ID of the link this Protection Manager is operating on
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-psdu.cc ns-3.38/src/wifi/model/wifi-psdu.cc
--- ns-3.37/src/wifi/model/wifi-psdu.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-psdu.cc	2023-03-16 20:54:23.868869300 -0700
@@ -139,6 +139,16 @@
     return ta;
 }
 
+bool
+WifiPsdu::HasNav() const
+{
+    // When the contents of a received Duration/ID field, treated as an unsigned integer,
+    // are greater than 32 768, the contents are interpreted as appropriate for the frame
+    // type and subtype or ignored if the receiving MAC entity does not have a defined
+    // interpretation for that type and subtype (IEEE 802.11-2016 sec. 10.27.3)
+    return (m_mpduList.at(0)->GetHeader().GetRawDuration() & 0x8000) == 0;
+}
+
 Time
 WifiPsdu::GetDuration() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-psdu.h ns-3.38/src/wifi/model/wifi-psdu.h
--- ns-3.37/src/wifi/model/wifi-psdu.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-psdu.h	2023-03-16 20:54:23.868869300 -0700
@@ -145,6 +145,11 @@
     Mac48Address GetAddr2() const;
 
     /**
+     * \return true if the Duration/ID field contains a value for setting the NAV
+     */
+    bool HasNav() const;
+
+    /**
      * Get the duration from the Duration/ID field, which is common to all the MPDUs
      * \return the duration from the Duration/ID field.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-remote-station-manager.cc ns-3.38/src/wifi/model/wifi-remote-station-manager.cc
--- ns-3.37/src/wifi/model/wifi-remote-station-manager.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-remote-station-manager.cc	2023-03-16 20:54:23.868869300 -0700
@@ -574,14 +574,13 @@
 {
     auto stateIt = m_states.find(mldAddress);
 
-    if (stateIt == m_states.end())
+    if (stateIt == m_states.end() || !stateIt->second->m_mldAddress)
     {
         // MLD address not found
-        return std::optional<Mac48Address>();
+        return std::nullopt;
     }
 
-    NS_ASSERT(stateIt->second->m_mldAddress.has_value() &&
-              *stateIt->second->m_mldAddress == mldAddress);
+    NS_ASSERT(*stateIt->second->m_mldAddress == mldAddress);
     return stateIt->second->m_address;
 }
 
@@ -598,7 +597,7 @@
         v.SetPreambleType(
             GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
         v.SetTxPowerLevel(m_defaultTxPowerLevel);
-        v.SetChannelWidth(GetChannelWidthForTransmission(mode, allowedWidth));
+        v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mode, allowedWidth));
         v.SetGuardInterval(ConvertGuardIntervalToNanoSeconds(mode, m_wifiPhy->GetDevice()));
         v.SetNTx(GetNumberOfAntennas());
         v.SetNss(1);
@@ -632,7 +631,7 @@
             }
         }
 
-        txVector.SetChannelWidth(GetChannelWidthForTransmission(mgtMode, channelWidth));
+        txVector.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mgtMode, channelWidth));
         txVector.SetGuardInterval(
             ConvertGuardIntervalToNanoSeconds(mgtMode, m_wifiPhy->GetDevice()));
     }
@@ -691,7 +690,7 @@
                         GetNumberOfAntennas(),
                         1,
                         0,
-                        GetChannelWidthForTransmission(defaultMode, m_wifiPhy->GetChannelWidth()),
+                        m_wifiPhy->GetTxBandwidth(defaultMode),
                         false);
 }
 
@@ -707,7 +706,7 @@
         v.SetPreambleType(
             GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()));
         v.SetTxPowerLevel(m_defaultTxPowerLevel);
-        v.SetChannelWidth(GetChannelWidthForTransmission(mode, m_wifiPhy->GetChannelWidth()));
+        v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(mode));
         v.SetGuardInterval(ConvertGuardIntervalToNanoSeconds(mode, m_wifiPhy->GetDevice()));
         v.SetNTx(GetNumberOfAntennas());
         v.SetNss(1);
@@ -727,7 +726,7 @@
     v.SetPreambleType(
         GetPreambleForTransmission(ctsMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
-    v.SetChannelWidth(GetChannelWidthForTransmission(ctsMode, m_wifiPhy->GetChannelWidth()));
+    v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(ctsMode));
     uint16_t ctsTxGuardInterval =
         ConvertGuardIntervalToNanoSeconds(ctsMode, m_wifiPhy->GetDevice());
     v.SetGuardInterval(ctsTxGuardInterval);
@@ -745,7 +744,7 @@
     v.SetPreambleType(
         GetPreambleForTransmission(ackMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
-    v.SetChannelWidth(GetChannelWidthForTransmission(ackMode, m_wifiPhy->GetChannelWidth()));
+    v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(ackMode));
     uint16_t ackTxGuardInterval =
         ConvertGuardIntervalToNanoSeconds(ackMode, m_wifiPhy->GetDevice());
     v.SetGuardInterval(ackTxGuardInterval);
@@ -764,7 +763,7 @@
     v.SetPreambleType(
         GetPreambleForTransmission(blockAckMode.GetModulationClass(), GetShortPreambleEnabled()));
     v.SetTxPowerLevel(GetDefaultTxPowerLevel());
-    v.SetChannelWidth(GetChannelWidthForTransmission(blockAckMode, m_wifiPhy->GetChannelWidth()));
+    v.SetChannelWidth(m_wifiPhy->GetTxBandwidth(blockAckMode));
     uint16_t blockAckTxGuardInterval =
         ConvertGuardIntervalToNanoSeconds(blockAckMode, m_wifiPhy->GetDevice());
     v.SetGuardInterval(blockAckTxGuardInterval);
@@ -1339,16 +1338,17 @@
     return LookupState(address)->m_info;
 }
 
-double
+std::optional<double>
 WifiRemoteStationManager::GetMostRecentRssi(Mac48Address address) const
 {
-    auto stationIt = m_stations.find(address);
-    NS_ASSERT_MSG(stationIt != m_stations.end(), "Address: " << address << " not found");
-    auto station = stationIt->second;
+    auto station = Lookup(address);
     auto rssi = station->m_rssiAndUpdateTimePair.first;
     auto ts = station->m_rssiAndUpdateTimePair.second;
-    NS_ASSERT_MSG(ts.IsStrictlyPositive(), "address: " << address << " ts:" << ts);
-    return rssi;
+    if (ts.IsStrictlyPositive())
+    {
+        return rssi;
+    }
+    return std::nullopt;
 }
 
 std::shared_ptr<WifiRemoteStationState>
@@ -1510,15 +1510,11 @@
         // todo: Using 3200ns, default value for HeConfiguration::GuardInterval
         state->m_guardInterval = 3200;
     }
-    for (uint8_t i = 1; i <= m_wifiPhy->GetMaxSupportedTxSpatialStreams(); i++)
+    for (const auto& mcs : m_wifiPhy->GetMcsList(WIFI_MOD_CLASS_HE))
     {
-        for (const auto& mcs : m_wifiPhy->GetMcsList(WIFI_MOD_CLASS_HE))
+        if (heCapabilities.GetHighestMcsSupported() >= mcs.GetMcsValue())
         {
-            if (heCapabilities.GetHighestNssSupported() >= i &&
-                heCapabilities.GetHighestMcsSupported() >= mcs.GetMcsValue())
-            {
-                AddSupportedMcs(from, mcs);
-            }
+            AddSupportedMcs(from, mcs);
         }
     }
     state->m_heCapabilities = Create<const HeCapabilities>(heCapabilities);
@@ -1532,7 +1528,17 @@
     // Used by all stations to record EHT capabilities of remote stations
     NS_LOG_FUNCTION(this << from << ehtCapabilities);
     auto state = LookupState(from);
-    // TODO: to be completed
+    for (const auto& mcs : m_wifiPhy->GetMcsList(WIFI_MOD_CLASS_EHT))
+    {
+        for (uint8_t mapType = 0; mapType < EhtMcsAndNssSet::EHT_MCS_MAP_TYPE_MAX; ++mapType)
+        {
+            if (ehtCapabilities.GetHighestSupportedRxMcs(
+                    static_cast<EhtMcsAndNssSet::EhtMcsMapType>(mapType)) >= mcs.GetMcsValue())
+            {
+                AddSupportedMcs(from, mcs);
+            }
+        }
+    }
     state->m_ehtCapabilities = Create<const EhtCapabilities>(ehtCapabilities);
     SetQosSupport(from, true);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-remote-station-manager.h ns-3.38/src/wifi/model/wifi-remote-station-manager.h
--- ns-3.37/src/wifi/model/wifi-remote-station-manager.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-remote-station-manager.h	2023-03-16 20:54:23.868869300 -0700
@@ -878,7 +878,7 @@
      * \param address the address of the receiver
      * \param nSuccessfulMpdus number of successfully transmitted MPDUs
      * A value of 0 means that the Block ACK was missed.
-     * \param nFailedMpdus number of unsuccessfully transmitted MPDUs
+     * \param nFailedMpdus number of unsuccessfuly transmitted MPDUs
      * \param rxSnr received SNR of the block ack frame itself
      * \param dataSnr data SNR reported by remote station
      * \param dataTxVector the TXVECTOR of the MPDUs we sent
@@ -973,7 +973,7 @@
      * to estimate the target UL RSSI info to put in the
      * Trigger frame to send to the remote station.
      */
-    double GetMostRecentRssi(Mac48Address address) const;
+    std::optional<double> GetMostRecentRssi(Mac48Address address) const;
     /**
      * Set the default transmission power level
      *
@@ -1342,7 +1342,7 @@
      * \param station the station that sent the DATA to us
      * \param nSuccessfulMpdus number of successfully transmitted MPDUs.
      *        A value of 0 means that the Block ACK was missed.
-     * \param nFailedMpdus number of unsuccessfully transmitted MPDUs.
+     * \param nFailedMpdus number of unsuccessfuly transmitted MPDUs.
      * \param rxSnr received SNR of the block ack frame itself
      * \param dataSnr data SNR reported by remote station
      * \param dataChannelWidth the channel width (in MHz) of the A-MPDU we sent
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-spectrum-phy-interface.cc ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.cc
--- ns-3.37/src/wifi/model/wifi-spectrum-phy-interface.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-spectrum-phy-interface.cc	2023-03-16 20:54:23.868869300 -0700
@@ -101,7 +101,6 @@
 Ptr<Object>
 WifiSpectrumPhyInterface::GetAntenna() const
 {
-    NS_LOG_FUNCTION(this);
     return m_spectrumWifiPhy->GetAntenna();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-spectrum-signal-parameters.cc ns-3.38/src/wifi/model/wifi-spectrum-signal-parameters.cc
--- ns-3.37/src/wifi/model/wifi-spectrum-signal-parameters.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-spectrum-signal-parameters.cc	2023-03-16 20:54:23.868869300 -0700
@@ -30,17 +30,19 @@
 NS_LOG_COMPONENT_DEFINE("WifiSpectrumSignalParameters");
 
 WifiSpectrumSignalParameters::WifiSpectrumSignalParameters()
-    : txCenterFreq(0)
+    : SpectrumSignalParameters(),
+      ppdu(nullptr),
+      txWidth(0)
 {
     NS_LOG_FUNCTION(this);
 }
 
 WifiSpectrumSignalParameters::WifiSpectrumSignalParameters(const WifiSpectrumSignalParameters& p)
-    : SpectrumSignalParameters(p)
+    : SpectrumSignalParameters(p),
+      ppdu(p.ppdu),
+      txWidth(p.txWidth)
 {
     NS_LOG_FUNCTION(this << &p);
-    ppdu = p.ppdu;
-    txCenterFreq = p.txCenterFreq;
 }
 
 Ptr<SpectrumSignalParameters>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-spectrum-signal-parameters.h ns-3.38/src/wifi/model/wifi-spectrum-signal-parameters.h
--- ns-3.37/src/wifi/model/wifi-spectrum-signal-parameters.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-spectrum-signal-parameters.h	2023-03-16 20:54:23.868869300 -0700
@@ -50,7 +50,7 @@
     WifiSpectrumSignalParameters(const WifiSpectrumSignalParameters& p);
 
     Ptr<const WifiPpdu> ppdu; ///< The PPDU being transmitted
-    uint16_t txCenterFreq;    ///< the center frequency of the transmitted signal in MHz
+    uint16_t txWidth;         ///< The TX width in MHz
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-standards.h ns-3.38/src/wifi/model/wifi-standards.h
--- ns-3.37/src/wifi/model/wifi-standards.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-standards.h	2023-03-16 20:54:23.868869300 -0700
@@ -95,7 +95,8 @@
     {WIFI_STANDARD_80211ac, {WIFI_PHY_BAND_5GHZ}},
     {WIFI_STANDARD_80211ad, {WIFI_PHY_BAND_60GHZ}},
     {WIFI_STANDARD_80211ax, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
-    {WIFI_STANDARD_80211be, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}}};
+    {WIFI_STANDARD_80211be, {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ}},
+};
 
 /**
  * \ingroup wifi
@@ -128,38 +129,6 @@
     }
 }
 
-/**
- * Get the maximum channel width in MHz allowed for the given standard.
- *
- * \param standard the standard
- * \return the maximum channel width in MHz allowed for the given standard
- */
-inline uint16_t
-GetMaximumChannelWidth(WifiStandard standard)
-{
-    switch (standard)
-    {
-    case WIFI_STANDARD_80211b:
-        return 22;
-    case WIFI_STANDARD_80211p:
-        return 10;
-    case WIFI_STANDARD_80211a:
-    case WIFI_STANDARD_80211g:
-        return 20;
-    case WIFI_STANDARD_80211n:
-        return 40;
-    case WIFI_STANDARD_80211ac:
-    case WIFI_STANDARD_80211ax:
-    case WIFI_STANDARD_80211be:
-        return 160;
-    case WIFI_STANDARD_80211ad:
-        return 2160;
-    default:
-        NS_ABORT_MSG("Unknown standard: " << standard);
-        return 0;
-    }
-}
-
 /**
  * Get the default channel width for the given PHY standard and band.
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-tx-timer.cc ns-3.38/src/wifi/model/wifi-tx-timer.cc
--- ns-3.37/src/wifi/model/wifi-tx-timer.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-tx-timer.cc	2023-03-16 20:54:23.868869300 -0700
@@ -107,6 +107,7 @@
         FOO(CTS);
         FOO(NORMAL_ACK);
         FOO(BLOCK_ACK);
+        FOO(CTS_AFTER_MU_RTS);
         FOO(NORMAL_ACK_AFTER_DL_MU_PPDU);
         FOO(BLOCK_ACKS_IN_TB_PPDU);
         FOO(TB_PPDU_AFTER_BASIC_TF);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-tx-timer.h ns-3.38/src/wifi/model/wifi-tx-timer.h
--- ns-3.37/src/wifi/model/wifi-tx-timer.h	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-tx-timer.h	2023-03-16 20:54:23.868869300 -0700
@@ -58,6 +58,7 @@
         WAIT_CTS,
         WAIT_NORMAL_ACK,
         WAIT_BLOCK_ACK,
+        WAIT_CTS_AFTER_MU_RTS,
         WAIT_NORMAL_ACK_AFTER_DL_MU_PPDU,
         WAIT_BLOCK_ACKS_IN_TB_PPDU,
         WAIT_TB_PPDU_AFTER_BASIC_TF,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-tx-vector.cc ns-3.38/src/wifi/model/wifi-tx-vector.cc
--- ns-3.37/src/wifi/model/wifi-tx-vector.cc	2022-11-01 17:37:24.759395800 -0700
+++ ns-3.38/src/wifi/model/wifi-tx-vector.cc	2023-03-16 20:54:23.868869300 -0700
@@ -23,6 +23,7 @@
 #include "wifi-phy-common.h"
 
 #include "ns3/abort.h"
+#include "ns3/eht-phy.h"
 
 #include <algorithm>
 #include <iterator>
@@ -31,7 +32,8 @@
 {
 
 WifiTxVector::WifiTxVector()
-    : m_preamble(WIFI_PREAMBLE_LONG),
+    : m_txPowerLevel(1),
+      m_preamble(WIFI_PREAMBLE_LONG),
       m_channelWidth(20),
       m_guardInterval(800),
       m_nTx(1),
@@ -42,9 +44,11 @@
       m_ldpc(false),
       m_bssColor(0),
       m_length(0),
+      m_triggerResponding(false),
       m_modeInitialized(false),
       m_inactiveSubchannels(),
-      m_ruAllocation()
+      m_ruAllocation(),
+      m_ehtPpduType(1) // SU transmission by default
 {
 }
 
@@ -60,7 +64,8 @@
                            bool stbc,
                            bool ldpc,
                            uint8_t bssColor,
-                           uint16_t length)
+                           uint16_t length,
+                           bool triggerResponding)
     : m_mode(mode),
       m_txPowerLevel(powerLevel),
       m_preamble(preamble),
@@ -74,9 +79,11 @@
       m_ldpc(ldpc),
       m_bssColor(bssColor),
       m_length(length),
+      m_triggerResponding(triggerResponding),
       m_modeInitialized(true),
       m_inactiveSubchannels(),
-      m_ruAllocation()
+      m_ruAllocation(),
+      m_ehtPpduType(1) // SU transmission by default
 {
 }
 
@@ -94,10 +101,12 @@
       m_ldpc(txVector.m_ldpc),
       m_bssColor(txVector.m_bssColor),
       m_length(txVector.m_length),
+      m_triggerResponding(txVector.m_triggerResponding),
       m_modeInitialized(txVector.m_modeInitialized),
       m_inactiveSubchannels(txVector.m_inactiveSubchannels),
       m_sigBMcs(txVector.m_sigBMcs),
-      m_ruAllocation(txVector.m_ruAllocation)
+      m_ruAllocation(txVector.m_ruAllocation),
+      m_ehtPpduType(txVector.m_ehtPpduType)
 {
     m_muUserInfos.clear();
     if (!txVector.m_muUserInfos.empty()) // avoids crashing for loop
@@ -127,13 +136,23 @@
     {
         NS_FATAL_ERROR("WifiTxVector mode must be set before using");
     }
-    if (IsMu())
+    if (!IsMu())
     {
-        NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU (" << staId << ")");
-        NS_ASSERT(m_muUserInfos.find(staId) != m_muUserInfos.end());
-        return m_muUserInfos.at(staId).mcs;
+        return m_mode;
+    }
+    NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU (" << staId << ")");
+    const auto userInfoIt = m_muUserInfos.find(staId);
+    NS_ASSERT(userInfoIt != m_muUserInfos.cend());
+    switch (GetModulationClassForPreamble(m_preamble))
+    {
+    case WIFI_MOD_CLASS_EHT:
+        return EhtPhy::GetEhtMcs(userInfoIt->second.mcs);
+    case WIFI_MOD_CLASS_HE:
+        return HePhy::GetHeMcs(userInfoIt->second.mcs);
+    default:
+        NS_ABORT_MSG("Unsupported modulation class: " << GetModulationClassForPreamble(m_preamble));
     }
-    return m_mode;
+    return WifiMode(); // invalid WifiMode
 }
 
 WifiModulationClass
@@ -145,7 +164,7 @@
     {
         NS_ASSERT(!m_muUserInfos.empty());
         // all the modes belong to the same modulation class
-        return m_muUserInfos.begin()->second.mcs.GetModulationClass();
+        return GetModulationClassForPreamble(m_preamble);
     }
     return m_mode.GetModulationClass();
 }
@@ -234,6 +253,13 @@
     return m_ldpc;
 }
 
+bool
+WifiTxVector::IsNonHtDuplicate() const
+{
+    return ((m_channelWidth >= 40) && !IsMu() &&
+            (GetMode().GetModulationClass() < WIFI_MOD_CLASS_HT));
+}
+
 void
 WifiTxVector::SetMode(WifiMode mode)
 {
@@ -246,7 +272,7 @@
 {
     NS_ABORT_MSG_IF(!IsMu(), "Not a MU transmission");
     NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU");
-    m_muUserInfos[staId].mcs = mode;
+    m_muUserInfos[staId].mcs = mode.GetMcsValue();
     m_modeInitialized = true;
 }
 
@@ -342,6 +368,18 @@
     return m_length;
 }
 
+bool
+WifiTxVector::IsTriggerResponding() const
+{
+    return m_triggerResponding;
+}
+
+void
+WifiTxVector::SetTriggerResponding(bool triggerResponding)
+{
+    m_triggerResponding = triggerResponding;
+}
+
 void
 WifiTxVector::SetSigBMode(const WifiMode& mode)
 {
@@ -357,7 +395,7 @@
 void
 WifiTxVector::SetRuAllocation(const RuAllocation& ruAlloc)
 {
-    if (IsDlMu() && !m_muUserInfos.empty())
+    if (ns3::IsDlMu(m_preamble) && !m_muUserInfos.empty())
     {
         NS_ASSERT(ruAlloc == DeriveRuAllocation());
     }
@@ -367,13 +405,26 @@
 const RuAllocation&
 WifiTxVector::GetRuAllocation() const
 {
-    if (IsDlMu() && m_ruAllocation.empty())
+    if (ns3::IsDlMu(m_preamble) && m_ruAllocation.empty())
     {
         m_ruAllocation = DeriveRuAllocation();
     }
     return m_ruAllocation;
 }
 
+void
+WifiTxVector::SetEhtPpduType(uint8_t type)
+{
+    NS_ASSERT(IsEht(m_preamble));
+    m_ehtPpduType = type;
+}
+
+uint8_t
+WifiTxVector::GetEhtPpduType() const
+{
+    return m_ehtPpduType;
+}
+
 bool
 WifiTxVector::IsValid() const
 {
@@ -413,13 +464,13 @@
 bool
 WifiTxVector::IsMu() const
 {
-    return ns3::IsMu(m_preamble);
+    return IsDlMu() || IsUlMu();
 }
 
 bool
 WifiTxVector::IsDlMu() const
 {
-    return ns3::IsDlMu(m_preamble);
+    return ns3::IsDlMu(m_preamble) && !(IsEht(m_preamble) && m_ehtPpduType == 1);
 }
 
 bool
@@ -456,8 +507,6 @@
 {
     NS_ABORT_MSG_IF(!IsMu(), "HE MU user info only available for MU");
     NS_ABORT_MSG_IF(staId > 2048, "STA-ID should be correctly set for MU");
-    NS_ABORT_MSG_IF(userInfo.mcs.GetModulationClass() < WIFI_MOD_CLASS_HE,
-                    "Only HE (or newer) modes authorized for MU");
     m_muUserInfos[staId] = userInfo;
     m_modeInitialized = true;
     m_ruAllocation.clear();
@@ -481,6 +530,11 @@
 std::pair<std::size_t, std::size_t>
 WifiTxVector::GetNumRusPerHeSigBContentChannel() const
 {
+    if (m_preamble == WIFI_PREAMBLE_EHT_MU && m_ehtPpduType == 1)
+    {
+        return {1, 0};
+    }
+
     // MU-MIMO is not handled for now, i.e. one station per RU
     auto ruAllocation = GetRuAllocation();
     NS_ASSERT_MSG(!ruAllocation.empty(), "RU allocation is not set");
@@ -563,13 +617,17 @@
     {
         os << " Length: " << v.GetLength();
     }
+    if (ns3::IsDlMu(v.GetPreambleType()))
+    {
+        os << " SIG-B mode: " << v.GetSigBMode();
+    }
     if (v.IsMu())
     {
         WifiTxVector::HeMuUserInfoMap userInfoMap = v.GetHeMuUserInfoMap();
         os << " num User Infos: " << userInfoMap.size();
         for (auto& ui : userInfoMap)
         {
-            os << ", {STA-ID: " << ui.first << ", " << ui.second.ru << ", MCS: " << ui.second.mcs
+            os << ", {STA-ID: " << ui.first << ", " << ui.second.ru << ", MCS: " << +ui.second.mcs
                << ", Nss: " << +ui.second.nss << "}";
         }
     }
@@ -585,13 +643,17 @@
                   puncturedSubchannels.cend(),
                   std::ostream_iterator<bool>(os, ", "));
     }
+    if (IsEht(v.GetPreambleType()))
+    {
+        os << " EHT PPDU type: " << +v.GetEhtPpduType();
+    }
     return os;
 }
 
 bool
 HeMuUserInfo::operator==(const HeMuUserInfo& other) const
 {
-    return ru == other.ru && mcs.GetMcsValue() == other.mcs.GetMcsValue() && nss == other.nss;
+    return ru == other.ru && mcs == other.mcs && nss == other.nss;
 }
 
 bool
